;;; **********************************************************************
;;; Copyright (C) 200 Todd Ingalls, <testcase (at) asu (dot) edu>
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the Lisp Lesser Gnu Public License.
;;; See http://www.cliki.net/LLGPL for the text of this agreement.
;;; **********************************************************************

;;; $Name: rel-1_0_1 $
;;; $Revision: 1.3 $
;;; $Date: 2006/06/02 07:02:18 $

(in-package :cl-user)

#-cm
(error "OSC requires Common Music to load.")

;; look for rts if not already loaded.
#-pthreads
(flet ((rts-probe (dir)
	 (let ((asd
		(first (directory
			(make-pathname :name "rts" :type "asd"
				       :directory
				       (append 
					(pathname-directory dir)
					(list :wild))
				       :defaults dir)))))
	   (if asd (push asd asdf:*central-registry*) nil))))
  (let* ((thisdir (make-pathname :type nil :name nil
				 :defaults (truename *load-pathname*)))
	 (rootdir (make-pathname :directory
				 (butlast (pathname-directory thisdir))
				 :defaults thisdir)))
    (or (rts-probe rootdir)
	(error "Atempt to load OSC without RTS loaded."))))

#+(or cmucl clisp)
(error "OSC not supported on this lisp, yet")

(asdf:defsystem :osc
  :description "OSC system for Common Music"
  :author "Todd Ingalls"
  :licence "LLGPL"
  :depends-on (rts)
  :serial t
  :components ((:file "sockets")
               (:file "osc" :depends-on ("sockets"))
	       (:file "osc-recv" :depends-on ("sockets"))
	       (:file "rt-sc" :depends-on ("osc"))))






